using System;
using System.Xml;
using System.ComponentModel;

namespace Lab5.Model
{
	public class Prestito
	{
		private readonly Biblioteca _owner;
		private readonly Libro _libro;
        private readonly Persona _persona;

        public Prestito(Biblioteca owner, Libro libro, Persona persona)
        {
            _owner = owner;
            _libro = libro;
            _persona = persona;
        }

        public Prestito(Biblioteca owner, XmlReader reader)
        {
            _owner = owner;
            _libro = _owner.GetLibro(XmlConvert.ToInt32(reader["idLibro"]));
            _persona = _owner.GetPersona(XmlConvert.ToInt32(reader["idPersona"]));
        }

        public void Salva(XmlWriter writer)
        {
            writer.WriteStartElement("Prestito");
            writer.WriteAttributeString("idLibro", XmlConvert.ToString(IdLibro));
            writer.WriteAttributeString("idPersona", XmlConvert.ToString(IdPersona));
            writer.WriteEndElement();
        }
		
        [Browsable(false)]
		public Biblioteca Owner
		{
			get { return _owner; }
		}

		public int IdLibro
		{
			get { return _libro.Id; }
		}

		public int IdPersona
		{
			get { return _persona.Id; }
		}

		public Libro Libro
		{
			get { return _libro; }
		}

		public Persona Persona
		{
			get { return _persona; }
		}

		public override string ToString()
		{
			return _libro.ToString() + " - " + _persona.ToString();
		}
	}
}
