﻿using System;
using System.Xml;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Lab5.Model;
using MiniLib.Model;
using MiniLib.Persistence;

namespace Lab5.Persistence
{
    public class BibliotecaPersister : PersisterBase
    {
        public BibliotecaPersister()
        {
        }

        public override void LoadDocument(DocumentBase document)
        {
            if (document == null)
                throw new ArgumentNullException("document");
            if (!(document is Biblioteca))
                throw new ApplicationException("!(document is Biblioteca)");
            Biblioteca biblioteca = (Biblioteca) document;
            XmlReaderSettings settings = new XmlReaderSettings();
            settings.IgnoreWhitespace = true;
            using (XmlReader reader = XmlReader.Create(FullFileName, settings))
            {
                biblioteca.Load(reader);
            }
        }

        public override void SaveDocument(DocumentBase document)
        {
            if (document == null)
                throw new ArgumentNullException("document");
            if (!(document is Biblioteca))
                throw new ApplicationException("!(document is Biblioteca)");
            Biblioteca biblioteca = (Biblioteca) document;
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.Indent = true;
            using (XmlWriter writer = XmlWriter.Create(FullFileName, settings))
            {
                biblioteca.Salva(writer);
            }
        }

        protected override void SetOpenFileDialog(OpenFileDialog openFileDialog)
        {
            base.SetOpenFileDialog(openFileDialog);
            openFileDialog.Filter = "XML Files|*.xml";
        }

        protected override void SetSaveFileDialog(SaveFileDialog saveFileDialog)
        {
            base.SetSaveFileDialog(saveFileDialog);
            saveFileDialog.Filter = "XML Files|*.xml";
        }
    }
}
